"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.arrayReducer = exports.ArrayActions = void 0;
var ArrayActions;
(function (ArrayActions) {
    ArrayActions["ADD_ITEM"] = "ADD_ITEM";
    ArrayActions["MOVE_ITEM"] = "MOVE_ITEM";
    ArrayActions["CLONE_ITEM"] = "CLONE_ITEM";
    ArrayActions["DELETE_ITEM"] = "DELETE_ITEM";
    ArrayActions["CHANGE_ITEM"] = "CHANGE_ITEM";
    ArrayActions["SET"] = "SET";
})(ArrayActions = exports.ArrayActions || (exports.ArrayActions = {}));
function arrayReducer(arr, action) {
    switch (action.action) {
        case ArrayActions.ADD_ITEM: {
            return __spreadArray(__spreadArray([], __read(arr), false), [action.value], false);
        }
        case ArrayActions.MOVE_ITEM: {
            var newArr = __spreadArray([], __read(arr), false);
            var existingItems = newArr.splice(action.index, 1);
            newArr.splice(action.targetIndex, 0, existingItems[0]);
            return newArr;
        }
        case ArrayActions.CLONE_ITEM: {
            return __spreadArray(__spreadArray(__spreadArray([], __read(arr.slice(0, action.index)), false), [arr[action.index]], false), __read(arr.slice(action.index)), false);
        }
        case ArrayActions.DELETE_ITEM: {
            return __spreadArray(__spreadArray([], __read(arr.slice(0, action.index)), false), __read(arr.slice(action.index + 1)), false);
        }
        case ArrayActions.CHANGE_ITEM: {
            var newArr = __spreadArray([], __read(arr), false);
            newArr[action.index] = action.value;
            return newArr;
        }
        case ArrayActions.SET: {
            return action.value;
        }
        default: {
            return [];
        }
    }
}
exports.arrayReducer = arrayReducer;
//# sourceMappingURL=arrayReducer.js.map